import{s as ke,n as Xe,o as We}from"../chunks/scheduler.85c25b89.js";import{S as Ye,i as ze,g as a,s as n,r as p,A as Fe,h as s,f as i,c as o,j as Se,u as m,x as r,k as je,y as Ne,a as l,v as d,d as c,t as f,w as h}from"../chunks/index.2f6a0e2a.js";import{C as we}from"../chunks/CodeBlock.2f5e6bad.js";import{H as F,E as Ve}from"../chunks/EditOnGithub.3872c048.js";function Be($e){let u,B,N,J,g,A,b,E,w,ye="The examples should work in any of the following settings (with the same script):",D,$,_e="<li>single GPU</li> <li>multi GPUS (using PyTorch distributed mode)</li> <li>multi GPUS (using DeepSpeed ZeRO-Offload stages 1, 2, &amp; 3)</li> <li>fp16 (mixed-precision), fp32 (normal precision), or bf16 (bfloat16 precision)</li>",O,y,xe=`To run it in each of these various modes, first initialize the accelerate
configuration with <code>accelerate config</code>`,I,_,Te="<strong>NOTE to train with a 4-bit or 8-bit model</strong>, please run",q,x,Q,T,K,M,Me="For all the examples, you’ll need to generate a 🤗 Accelerate config file with:",ee,v,te,U,ve="Then, it is encouraged to launch jobs with <code>accelerate launch</code>!",ie,C,le,P,Ue='<thead><tr><th>File</th> <th>Description</th></tr></thead> <tbody><tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/sft.py" rel="nofollow"><code>examples/scripts/sft.py</code></a></td> <td>This script shows how to use the <code>SFTTrainer</code> to fine tune a model or adapters into a target dataset.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/vsft_llava.py" rel="nofollow"><code>examples/scripts/vsft_llava.py</code></a></td> <td>This script shows how to use the <code>SFTTrainer</code> to fine tune a Vision Language Model in a chat setting, the script has been tested on a llava1.5 model so users may see unexpected behaviour in other model architectures.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/reward_modeling.py" rel="nofollow"><code>examples/scripts/reward_modeling.py</code></a></td> <td>This script shows how to use the <code>RewardTrainer</code> to train a reward model on your own dataset.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/ppo.py" rel="nofollow"><code>examples/scripts/ppo.py</code></a></td> <td>This script shows how to use the <code>PPOTrainer</code> to fine-tune a sentiment analysis model using IMDB dataset</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/ppo_multi_adapter.py" rel="nofollow"><code>examples/scripts/ppo_multi_adapter.py</code></a></td> <td>This script shows how to use the <code>PPOTrainer</code> to train a single base model with multiple adapters. Requires you to run the example script with the reward model training beforehand.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/stable_diffusion_tuning_example.py" rel="nofollow"><code>examples/scripts/stable_diffusion_tuning_example.py</code></a></td> <td>This script shows to use DDPOTrainer to fine-tune a stable diffusion model using reinforcement learning.</td></tr></tbody>',ne,G,Ce="Here are also some easier-to-run colab notebooks that you can use to get started with TRL:",oe,L,Pe='<thead><tr><th>File</th> <th>Description</th></tr></thead> <tbody><tr><td><a href="https://github.com/huggingface/trl/tree/main/examples/notebooks/best_of_n.ipynb" rel="nofollow"><code>examples/notebooks/best_of_n.ipynb</code></a></td> <td>This notebook demonstrates how to use the “Best of N” sampling strategy using TRL when fine-tuning your model with PPO.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/tree/main/examples/notebooks/gpt2-sentiment.ipynb" rel="nofollow"><code>examples/notebooks/gpt2-sentiment.ipynb</code></a></td> <td>This notebook demonstrates how to reproduce the GPT2 imdb sentiment tuning example on a jupyter notebook.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/tree/main/examples/notebooks/gpt2-control.ipynb" rel="nofollow"><code>examples/notebooks/gpt2-control.ipynb</code></a></td> <td>This notebook demonstrates how to reproduce the GPT2 sentiment control example on a jupyter notebook.</td></tr></tbody>',ae,Z,Ge="We also have some other examples that are less maintained but can be used as a reference:",se,H,Le='<li><strong><a href="https://github.com/huggingface/trl/tree/main/examples/research_projects" rel="nofollow">research_projects</a></strong>: Check out this folder to find the scripts used for some research projects that used TRL (LM de-toxification, Stack-Llama, etc.)</li>',re,R,pe,S,Ze="All of the scripts can be run on multiple GPUs by providing the path of an 🤗 Accelerate config file when calling <code>accelerate launch</code>. To launch one of them on one or multiple GPUs, run the following command (swapping <code>{NUM_GPUS}</code> with the number of GPUs in your machine and <code>--all_arguments_of_the_script</code> with your arguments.)",me,j,de,k,He="You can also adjust the parameters of the 🤗 Accelerate config file to suit your needs (e.g. training in mixed precision).",ce,X,fe,W,Re="Most of the scripts can be run on multiple GPUs together with DeepSpeed ZeRO-{1,2,3} for efficient sharding of the optimizer states, gradients, and model weights. To do so, run following command (swapping <code>{NUM_GPUS}</code> with the number of GPUs in your machine, <code>--all_arguments_of_the_script</code> with your arguments, and <code>--deepspeed_config</code> with the path to the DeepSpeed config file such as <code>examples/deepspeed_configs/deepspeed_zero1.yaml</code>):",he,Y,ue,z,ge,V,be;return g=new F({props:{title:"Examples",local:"examples",headingTag:"h1"}}),b=new F({props:{title:"Introduction",local:"introduction",headingTag:"h2"}}),x=new we({props:{code:"cGlwJTIwaW5zdGFsbCUyMC0tdXBncmFkZSUyMHRybCU1QnF1YW50aXphdGlvbiU1RA==",highlighted:"pip install --upgrade trl[quantization]",wrap:!1}}),T=new F({props:{title:"Accelerate Config",local:"accelerate-config",headingTag:"h2"}}),v=new we({props:{code:"YWNjZWxlcmF0ZSUyMGNvbmZpZyUyMCUyMyUyMHdpbGwlMjBwcm9tcHQlMjB5b3UlMjB0byUyMGRlZmluZSUyMHRoZSUyMHRyYWluaW5nJTIwY29uZmlndXJhdGlvbg==",highlighted:"accelerate config # will prompt you to define the training configuration",wrap:!1}}),C=new F({props:{title:"Maintained Examples",local:"maintained-examples",headingTag:"h1"}}),R=new F({props:{title:"Distributed training",local:"distributed-training",headingTag:"h2"}}),j=new we({props:{code:"YWNjZWxlcmF0ZSUyMGxhdW5jaCUyMC0tY29uZmlnX2ZpbGUlM0RleGFtcGxlcyUyRmFjY2VsZXJhdGVfY29uZmlncyUyRm11bHRpX2dwdS55YW1sJTIwLS1udW1fcHJvY2Vzc2VzJTIwJTdCTlVNX0dQVVMlN0QlMjBwYXRoX3RvX3NjcmlwdC5weSUyMC0tYWxsX2FyZ3VtZW50c19vZl90aGVfc2NyaXB0",highlighted:"accelerate launch --config_file=examples/accelerate_configs/multi_gpu.yaml --num_processes {NUM_GPUS} path_to_script.py --all_arguments_of_the_script",wrap:!1}}),X=new F({props:{title:"Distributed training with DeepSpeed",local:"distributed-training-with-deepspeed",headingTag:"h3"}}),Y=new we({props:{code:"YWNjZWxlcmF0ZSUyMGxhdW5jaCUyMC0tY29uZmlnX2ZpbGUlM0RleGFtcGxlcyUyRmFjY2VsZXJhdGVfY29uZmlncyUyRmRlZXBzcGVlZF96ZXJvJTdCMSUyQzIlMkMzJTdELnlhbWwlMjAtLW51bV9wcm9jZXNzZXMlMjAlN0JOVU1fR1BVUyU3RCUyMHBhdGhfdG9fc2NyaXB0LnB5JTIwLS1hbGxfYXJndW1lbnRzX29mX3RoZV9zY3JpcHQ=",highlighted:"accelerate launch --config_file=examples/accelerate_configs/deepspeed_zero{1,2,3}.yaml --num_processes {NUM_GPUS} path_to_script.py --all_arguments_of_the_script",wrap:!1}}),z=new Ve({props:{source:"https://github.com/huggingface/trl/blob/main/docs/source/example_overview.md"}}),{c(){u=a("meta"),B=n(),N=a("p"),J=n(),p(g.$$.fragment),A=n(),p(b.$$.fragment),E=n(),w=a("p"),w.textContent=ye,D=n(),$=a("ul"),$.innerHTML=_e,O=n(),y=a("p"),y.innerHTML=xe,I=n(),_=a("p"),_.innerHTML=Te,q=n(),p(x.$$.fragment),Q=n(),p(T.$$.fragment),K=n(),M=a("p"),M.textContent=Me,ee=n(),p(v.$$.fragment),te=n(),U=a("p"),U.innerHTML=ve,ie=n(),p(C.$$.fragment),le=n(),P=a("table"),P.innerHTML=Ue,ne=n(),G=a("p"),G.textContent=Ce,oe=n(),L=a("table"),L.innerHTML=Pe,ae=n(),Z=a("p"),Z.textContent=Ge,se=n(),H=a("ol"),H.innerHTML=Le,re=n(),p(R.$$.fragment),pe=n(),S=a("p"),S.innerHTML=Ze,me=n(),p(j.$$.fragment),de=n(),k=a("p"),k.textContent=He,ce=n(),p(X.$$.fragment),fe=n(),W=a("p"),W.innerHTML=Re,he=n(),p(Y.$$.fragment),ue=n(),p(z.$$.fragment),ge=n(),V=a("p"),this.h()},l(e){const t=Fe("svelte-u9bgzb",document.head);u=s(t,"META",{name:!0,content:!0}),t.forEach(i),B=o(e),N=s(e,"P",{}),Se(N).forEach(i),J=o(e),m(g.$$.fragment,e),A=o(e),m(b.$$.fragment,e),E=o(e),w=s(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1qml164"&&(w.textContent=ye),D=o(e),$=s(e,"UL",{"data-svelte-h":!0}),r($)!=="svelte-y1bwso"&&($.innerHTML=_e),O=o(e),y=s(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1gk4czs"&&(y.innerHTML=xe),I=o(e),_=s(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1uwpnnm"&&(_.innerHTML=Te),q=o(e),m(x.$$.fragment,e),Q=o(e),m(T.$$.fragment,e),K=o(e),M=s(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-8m9xl"&&(M.textContent=Me),ee=o(e),m(v.$$.fragment,e),te=o(e),U=s(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1fatpmt"&&(U.innerHTML=ve),ie=o(e),m(C.$$.fragment,e),le=o(e),P=s(e,"TABLE",{"data-svelte-h":!0}),r(P)!=="svelte-cm4ncy"&&(P.innerHTML=Ue),ne=o(e),G=s(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-8xuvqq"&&(G.textContent=Ce),oe=o(e),L=s(e,"TABLE",{"data-svelte-h":!0}),r(L)!=="svelte-17wv7zp"&&(L.innerHTML=Pe),ae=o(e),Z=s(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-nr1j2l"&&(Z.textContent=Ge),se=o(e),H=s(e,"OL",{"data-svelte-h":!0}),r(H)!=="svelte-ks8v1x"&&(H.innerHTML=Le),re=o(e),m(R.$$.fragment,e),pe=o(e),S=s(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-1wqljqa"&&(S.innerHTML=Ze),me=o(e),m(j.$$.fragment,e),de=o(e),k=s(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-12yw9zf"&&(k.textContent=He),ce=o(e),m(X.$$.fragment,e),fe=o(e),W=s(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-155h86t"&&(W.innerHTML=Re),he=o(e),m(Y.$$.fragment,e),ue=o(e),m(z.$$.fragment,e),ge=o(e),V=s(e,"P",{}),Se(V).forEach(i),this.h()},h(){je(u,"name","hf:doc:metadata"),je(u,"content",Je)},m(e,t){Ne(document.head,u),l(e,B,t),l(e,N,t),l(e,J,t),d(g,e,t),l(e,A,t),d(b,e,t),l(e,E,t),l(e,w,t),l(e,D,t),l(e,$,t),l(e,O,t),l(e,y,t),l(e,I,t),l(e,_,t),l(e,q,t),d(x,e,t),l(e,Q,t),d(T,e,t),l(e,K,t),l(e,M,t),l(e,ee,t),d(v,e,t),l(e,te,t),l(e,U,t),l(e,ie,t),d(C,e,t),l(e,le,t),l(e,P,t),l(e,ne,t),l(e,G,t),l(e,oe,t),l(e,L,t),l(e,ae,t),l(e,Z,t),l(e,se,t),l(e,H,t),l(e,re,t),d(R,e,t),l(e,pe,t),l(e,S,t),l(e,me,t),d(j,e,t),l(e,de,t),l(e,k,t),l(e,ce,t),d(X,e,t),l(e,fe,t),l(e,W,t),l(e,he,t),d(Y,e,t),l(e,ue,t),d(z,e,t),l(e,ge,t),l(e,V,t),be=!0},p:Xe,i(e){be||(c(g.$$.fragment,e),c(b.$$.fragment,e),c(x.$$.fragment,e),c(T.$$.fragment,e),c(v.$$.fragment,e),c(C.$$.fragment,e),c(R.$$.fragment,e),c(j.$$.fragment,e),c(X.$$.fragment,e),c(Y.$$.fragment,e),c(z.$$.fragment,e),be=!0)},o(e){f(g.$$.fragment,e),f(b.$$.fragment,e),f(x.$$.fragment,e),f(T.$$.fragment,e),f(v.$$.fragment,e),f(C.$$.fragment,e),f(R.$$.fragment,e),f(j.$$.fragment,e),f(X.$$.fragment,e),f(Y.$$.fragment,e),f(z.$$.fragment,e),be=!1},d(e){e&&(i(B),i(N),i(J),i(A),i(E),i(w),i(D),i($),i(O),i(y),i(I),i(_),i(q),i(Q),i(K),i(M),i(ee),i(te),i(U),i(ie),i(le),i(P),i(ne),i(G),i(oe),i(L),i(ae),i(Z),i(se),i(H),i(re),i(pe),i(S),i(me),i(de),i(k),i(ce),i(fe),i(W),i(he),i(ue),i(ge),i(V)),i(u),h(g,e),h(b,e),h(x,e),h(T,e),h(v,e),h(C,e),h(R,e),h(j,e),h(X,e),h(Y,e),h(z,e)}}}const Je='{"title":"Examples","local":"examples","sections":[{"title":"Introduction","local":"introduction","sections":[],"depth":2},{"title":"Accelerate Config","local":"accelerate-config","sections":[],"depth":2}],"depth":1}';function Ae($e){return We(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qe extends Ye{constructor(u){super(),ze(this,u,Ae,Be,ke,{})}}export{qe as component};
